//
//  Motor.hpp
//  Index
//
//  Created by  on 2018/08/14.
//  Copyright © 2018年 . All rights reserved.
//

#ifndef Motor_hpp
#define Motor_hpp

#include "mbed.h"
#include <stdio.h>
#include <iostream>
#include <algorithm>

#define CW_DUTY 50
#define CCW_DUTY 51
#define CW_CURRENT 55
#define CCW_CURRENT 56
#define BRAKE 60
#define PWM_BRAKE 61
#define FREE 70
#define CHECKMODE 80


class MotorDriver{
private:
    SPI* MD;
    DigitalOut* CS;
    Ticker* comm;
    int m_mode;
    int m_strength;
    int m_driver_mode;
    int m_driver_current;
    int m_last_received_random_num;
    int m_last_sent_random_num;
    
public:
    MotorDriver(SPI* spi_module,PinName CSpin);
    int write(float duty);
    int writeCurrent(float current);
    int brake();
    int brake(float duty);
    int stop();
    float getCurrent();
    void communication();
};

#endif /* Motor_hpp */
